﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Sub Class_Globals
Type sp_par(x As Int, y As Int, az As Double, vx As Double, vy As Double)	
Dim s As sp_par
Private azimuth, spv As Double
Private cmodule As Game
Private gif As GifDecoder
Dim spview As ImageView
Dim spmode As Int
Dim myindex As Int
Private  Frame,  counter, listcounter As Int
Dim sptmr, giftmr As Timer
Private myparent As View
End Sub

'Initializes the sprite object.
'Module is the Game object that launched this sprite, used for access to the game class.
'Parent is the Game class panel which is used as the game zone. Needed for the limits of the playground.
'index - the index of the sprite type
Public Sub Initialize(Module As Object,Parent As View,index As Int)
spview.Initialize("spview")
cmodule = Module
myparent = Parent
myindex = index
spmode = cmodule.R(index).Walk

spv = Rnd(cmodule.R(index).maxv/3, cmodule.R(index).maxv)
s.x = cmodule.R(index).x0
s.y = cmodule.R(index).y0
If spmode = 0 Then ' free_fly
	azimuth = Rnd(cmodule.R(index).azmin , cmodule.R(index).azmax) 
	s.az = azimuth
	s.vx =  spv * SinD(azimuth)
	s.vy = -spv * CosD(azimuth)
Else               ' path_walk
	listcounter = 0
	azimuth = ATan2D(cmodule.xlst.Get(0)-cmodule.R(index).x0,cmodule.R(index).y0- cmodule.ylst.Get(0))
	s.vx =  spv * SinD(azimuth)
	s.vy = -spv * CosD(azimuth)
End If
sptmr.Initialize("sptmr", 300 + Rnd(10,30))
sptmr.Enabled = True

cmodule.UpdateSprite(Me)  ' use update for add - its the same action
counter = 0

giftmr.Initialize("giftmr",10)
gif.DisposeFrames
gif.Load(File.DirAssets, cmodule.R(index).pic)
Frame = 0
giftmr.Interval = Max(gif.delay(Frame),cmodule.R(index).delay)
spview.Bitmap = gif.Frame(Frame)
spview.Gravity = Gravity.FILL
giftmr.Enabled = True
End Sub

Sub AsView As View
Return spview
End Sub

Private Sub sptmr_tick
s.x = s.x + s.vx
s.y = s.y + s.vy 
spview.Left = s.x - spview.Width/2
spview.Top  = s.y - spview.Height/2
If spmode = 0 Then
	If s.x > myparent.Left + myparent.Width - spview.Width/2 Then
		s.vx = -s.vx
		s.x = myparent.Left + myparent.Width - spview.Width/2
	End If		
	If	s.x < myparent.Left + spview.Width/2 Then
		s.vx = -s.vx
		s.x = myparent.Left + spview.Width/2
	End If
	If s.y > myparent.top+myparent.height - spview.Height/2 Then
		s.vy = -s.vy
		s.y = myparent.top+myparent.height - spview.Height/2
	End If
	If	s.y < myparent.top + spview.Height/2 Then 
		s.vy = -s.vy
		s.y = myparent.top + spview.Height/2 
	End If 
Else
	azimuth = ATan2D(cmodule.xlst.Get(listcounter)-s.x,s.y - cmodule.ylst.Get(listcounter))
	s.vx =  spv * SinD(azimuth)
	s.vy = -spv * CosD(azimuth)	   	
	If Abs(cmodule.xlst.Get(listcounter)-s.x)< spview.width/5 AND _
	   Abs(cmodule.ylst.Get(listcounter)-s.y)< spview.height/5 Then
			If listcounter = cmodule.xlst.Size - 1 Then 
				cmodule.RemoveSprite(Me)
				Return
			Else
				listcounter = listcounter + 1
			End If
	   End If
End If
cmodule.UpdateSprite(Me) 
counter = counter + 1
cmodule.CheckCollision(Me)
End Sub

Private Sub giftmr_tick
giftmr.Enabled = False
Frame = Frame + 1
If Frame >= gif.FrameCount Then
	Frame = 0
End If
giftmr.Interval = Max(gif.delay(Frame),cmodule.R(myindex).delay)
spview.Bitmap = gif.Frame(Frame)
giftmr.Enabled = True
End Sub

Private Sub spview_click
cmodule.explode(Me,Null)
End Sub

